import { Session, Layout, Theme } from 'dripcap';

export default class TCP {
  activate() {
    Layout.require(__dirname + '/../tag/minecraft-pos.tag');
    Layout.require(__dirname + '/../tag/minecraft-time.tag');
    Session.registerStreamDissector(`${__dirname}/minecraft.es`);
    Session.registerFilterHints('minecraft', [
      {filter: 'minecraft', description: 'Minecraft'}
    ]);
    Theme.registerScheme('minecraft', {
      name: 'Minecraft',
      css: [`${__dirname}/../style/mine.css`]
    });
    Theme.setId('minecraft');
  }

  deactivate() {
    Layout.unregister('packet-view-minecraft-pos');
    Layout.unregister('packet-view-minecraft-time');
    Session.unregisterStreamDissector(`${__dirname}/minecraft.es`);
    Session.unregisterFilterHints('minecraft');
    Theme.unregisterScheme('minecraft');
  }
}
