<packet-view-minecraft-pos>
  <style type="text/less">
    :scope {
      canvas {
        vertical-align: top;
        margin: 10px;
      }
    }
  </style>
  <script>
    const THREE = require('three-js')();
    const $ = require('jquery');
    this.on('mount', () => {
      let scene = new THREE.Scene();

      let width = 400;
      let height = 250;
      let camera = new THREE.PerspectiveCamera( 30, width / height, 1, 10000 );
      camera.position.x = 3200;
      camera.position.y = 700;
      camera.position.z = 3200;
      camera.lookAt(new THREE.Vector3(0, 0, 0));

      let xgeo = new THREE.Geometry();
      xgeo.vertices.push(
        new THREE.Vector3(-10000, 0, 0),
        new THREE.Vector3(10000, 0, 0)
      );
      let ygeo = new THREE.Geometry();
      ygeo.vertices.push(
        new THREE.Vector3(0, -10000, 0),
        new THREE.Vector3(0, 10000, 0)
      );
      let zgeo = new THREE.Geometry();
      zgeo.vertices.push(
        new THREE.Vector3(0, 0, -10000),
        new THREE.Vector3(0, 0, 10000)
      );

      let xmesh = new THREE.Line(xgeo, new THREE.LineBasicMaterial({ color: 0xff0000 }));
      let ymesh = new THREE.Line(ygeo, new THREE.LineBasicMaterial({ color: 0x000000 }));
      let zmesh = new THREE.Line(zgeo, new THREE.LineBasicMaterial({ color: 0x0000ff }));
      scene.add(xmesh);
      scene.add(ymesh);
      scene.add(zmesh);

      for (let i = -25; i <= 25; ++i) {
        let xgeo = new THREE.Geometry();
        xgeo.vertices.push(
          new THREE.Vector3(-10000, 0, i * 100),
          new THREE.Vector3(10000, 0, i * 100)
        );
        let xmesh = new THREE.Line(xgeo, new THREE.LineBasicMaterial({ color: 0xff0000, opacity: 0.3, transparent: true }));
        scene.add(xmesh);
      }
      for (let i = -25; i <= 25; ++i) {
        let zgeo = new THREE.Geometry();
        zgeo.vertices.push(
          new THREE.Vector3(i * 100, 0, -10000),
          new THREE.Vector3(i * 100, 0, 10000)
        );
        let zmesh = new THREE.Line(zgeo, new THREE.LineBasicMaterial({ color: 0x0000ff, opacity: 0.3, transparent: true }));
        scene.add(zmesh);
      }

      let sphere = new THREE.Mesh(new THREE.SphereGeometry(12, 32, 32),
                    new THREE.MeshBasicMaterial({color: 0xff0000}));

      sphere.position.x = opts.val[0];
      sphere.position.y = opts.val[1];
      sphere.position.z = opts.val[2];
      scene.add(sphere);

      let renderer = new THREE.WebGLRenderer({antialias: true});
      renderer.setClearColor(0xc4c4ab, 1);
      renderer.setSize(width, height);

      $(this.root).append(renderer.domElement);

      let count = 0;
      clearInterval(this.interval);
      this.interval = setInterval(() => {
        count++;
        sphere.visible = count % 2;
        camera.position.x = Math.cos(count / 500) * 1200;
        camera.position.z = -Math.sin(count / 500) * 1200;
        camera.lookAt(new THREE.Vector3(0, 0, 0));
        renderer.render(scene, camera);
      }, 10);
    });
    this.on('unmount', () => {
      clearInterval(this.interval);
    });
  </script>
</packet-view-minecraft-pos>
